<?php
/**
 * 金魚屋開発支援シリーズ
 * 金魚屋コメント登録コンポーネント
 * 管理画面表示スクリプト
 * 
 * 金魚屋開発支援シリーズ
 * 
 * @package Joomla
 * @component com_kingyoya_comment
 * @copyright (C) 2008 金魚屋見聞録
 * @author 金魚屋・Ｊ・龍角
 * @version 1.0.0
 */

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

/**
 * コメント登録管理画面表示クラス
 */
class ADMIN_HTML_kingyoya_comment {

	function show_header($title) {
		?>

		<table class="adminheading">
			<tr>
				<th><?php echo $title; ?></th>
			</tr>
		</table>
		<?php
	}

	/**
	 * HTML エスケープされた文字列を返す
	 * @param string str
	 */
	function escape_string($str) {
		if (!$str) { return null; }
		return htmlspecialchars($str, ENT_QUOTES, mb_internal_encoding());
	}

	/**
	 * フォームのhidden 要素を出力する
	 * @param string name name属性値
	 * @param string value value属性値
	 */
	function show_hidden($name, $value = '') {
		if (!$name || !is_string($name)) {
			trigger_error("Unvalid name", E_USER_WARNING);
			return null;
		}
		if ($value && !is_string($value)) {
			trigger_error("Unvalid value", E_USER_WARNING);
			return null;
		}

		?><input type="hidden" name="<?php
		echo ADMIN_HTML_kingyoya_comment::escape_string($name);
		?>" value="<?php
		echo ADMIN_HTML_kingyoya_comment::escape_string($value);
		?>" /><?php
	}

	/**
	 * 登録コメント一覧表示
	 * @static
	 * @param array &rows
	 * @param array &group list
	 * @param mosPageNav &pageNav
	 * @param string &option
	 */
	function show_list(&$rows, &$pageNav, $option) {
		if (!is_array($rows)) {
			trigger_error("Unvalid rows", E_USER_WARNING);
			return;
		}
		if (!is_object($pageNav)) {
			trigger_error("Unvalid pageNav", E_USER_WARNING);
			return;
		}
		if (!$option || !is_string($option)) {
			trigger_error("Unvalid option: {$option}", E_USER_WARNING);
			return;
		}

		mosKingyoyaAdminHTML::showHeader('登録一覧', 'edit');
		mosKingyoyaAdminHTML::showFormHeader($option);

?>
<p style="text-align: right">
	<label>group:<input type="text" name="group" size="20" maxlength="255" /></label>
	<input type="submit" value="検索" />
</p>
<?php

		$adminhtml = mosKingyoyaAdminHTML::factory('list', $option);
		$adminhtml->pageNav($pageNav);
		$adminhtml->appendRowNumberField('#', '10');
		$adminhtml->appendCheckboxField('10');
		$adminhtml->appendField('id', 'ID', null, '10');
		$adminhtml->appendField('group', 'GROUP');
		$adminhtml->appendField('target', 'TARGET');
		$adminhtml->appendField('name', 'NAME');
		$adminhtml->appendField('comment', 'COMMENT');
		$adminhtml->appendField('publish', '公開');
		$adminhtml->appendField('modified', '更新');
		$adminhtml->appendField('created', '作成');

		foreach ($rows as $row) {
			$escaped_group = htmlspecialchars($row->group, ENT_QUOTES);
			$line = $adminhtml->createRow();
			$line->id($row->id);
			$line->field('group', "<a href=\"./index2.php?option={$option}&group={$escaped_group}\">{$escaped_group}</a>");
			$line->field('target', htmlspecialchars($row->target));
			$line->field('name', htmlspecialchars($row->name));
			$comment = $row->comment;
			$comment and $comment = htmlspecialchars($comment, ENT_QUOTES);
			$comment and $comment = str_replace("\n", '<br />', $comment);
			$line->field('comment', $comment);
			if ($row->publish) {
				$line->field('publish', '<a href="javascript: document.adminForm.id.value=\''.$row->id.'.\';submitbutton(\'unpublish\')"><img src="./images/publish_g.png" style="border: none" /></a>');
			} else {
				$line->field('publish', '<a href="javascript: document.adminForm.id.value=\''.$row->id.'.\';submitbutton(\'publish\')"><img src="./images/publish_x.png" style="border: none" /></a>');
			}
			$created = $row->created('Y-m-d H:i:s');
			$created_by = $row->created_by('name');
			$line->field('created', "{$created}<br />{$created_by}");
			$modified = $row->modified('Y-m-d H:i:s');
			$modified_by = $row->modified_by('name');
			$line->field('modified', "{$modified}<br />{$modified_by}");
			$adminhtml->appendRow($line);
		}

		$adminhtml->show();

		mosKingyoyaAdminHTML::showFormFooter($option);
	}

}

