<?php
/**
 * 金魚屋開発支援シリーズ
 * 金魚屋コメント登録コンポーネント
 * 管理画面処理スクリプト
 * 
 * 金魚屋開発支援シリーズ
 * 
 * @package Joomla
 * @component com_kingyoya_comment
 * @copyright (C) 2008 金魚屋見聞録
 * @author 金魚屋・Ｊ・龍角
 * @version 1.0.0
 */

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

global $_MAMBOTS;
$_MAMBOTS->loadBotGroup( 'Kingyoya' );

require_once $mainframe->getPath('class', $option);

if (!$option) {
	trigger_error("Failed get option", E_USER_WARNING);
	return;
}
if ($option === 'com_kingyoya_comment') {
	if (!ctype_print($option)) {
		trigger_error("Unvalid option: {$option}", E_USER_WARNING);
		return;
	}
	if ($task && !ctype_print($task)) {
		trigger_error("Unvalid task: {$task}", E_USER_WARNING);
		return;
	}

	switch($task) {
		case 'publish':
			ADMIN_kingyoya_comment::publish($option, true);
			break;
		case 'unpublish':
			ADMIN_kingyoya_comment::publish($option, false);
			break;
		case 'help':
			ADMIN_kingyoya_comment::show_help($option);
			break;
		case 'list':
		default:
			ADMIN_kingyoya_comment::show_list($option);
			break;
	}
}

/**
 * コメント登録管理画面処理クラス
 */
class ADMIN_kingyoya_comment {

	/**
	 * 登録コメント一覧表示
	 * @static
	 * @param string option
	 */
	function show_list($option) {
		global $mainframe;
		global $database;
		global $mosConfig_absolute_path;
		global $mosConfig_list_limit;

		if (!$option) {
			trigger_error("Failed get option", E_USER_WARNING);
			return;
		}
		if (!ctype_print($option)) {
			trigger_error("Unvalid option: {$option}", E_USER_WARNING);
			return;
		}
		$offset = intval( $mainframe->getUserStateFromRequest( "{$option}listoffset", 'limitstart', 0 ) );
		$limit = intval( $mainframe->getUserStateFromRequest( "{$option}listlimit", 'limit', $mosConfig_list_limit ) );
		require_once( $mosConfig_absolute_path . '/administrator/includes/pageNavigation.php' );

		$rows = new mosKingyoyacomment($database);
		$rows->appendOrderBy('id', false);
		$result = $rows->find();
		if (!$result) {
			die(var_dump($rows->getError()));
		}
		$total = $rows->count();
		$pageNav = new mosPageNav( $total, $offset, $limit );

		if ($group = mosGetParam($_REQUEST, 'group')) {
			/* group で絞込み */
			$rows->group = $group;
		}

		$result = $rows->find($offset, $limit);
		if (!$result) {
			die(var_dump($rows->getError()));
		}
		$list = array();
		while ($rows->next()) {
			$list[] =& $rows->copy();
		}

		require_once $mainframe->getPath('admin_html', $option);
		ADMIN_HTML_kingyoya_comment::show_list($list, $pageNav, $option);
	}
	/* to 登録コメント一覧表示 */

	/**
	 * ヘルプを表示
	 */
	function show_help($option) {
		global $mainframe;
		global $mosConfig_absolute_path;
require_once( $mosConfig_absolute_path . '/includes/domit/xml_domit_lite_include.php' );
$xml = new DOMIT_Lite_Document();
$xml->resolveErrors( true );
$result = $xml->loadXML($mainframe->getPath('com_xml', $option));
if (!$result) {
	header('HTTP/1.0 500 Internal Server Error');
	echo '<h1>We meet the Expectation Error!</h1>';
	return;
}

?>

<table class="adminheading">
	<tr>
		<th class="info">説明</th>
	</tr>
</table>
<table class="adminlist">
	<tr>
		<td>
<?php

$root =& $xml->documentElement;
$description =& $root->getElementsByPath('description', 1);
echo $description->gettext();

?>

		<td>
	</tr>
</table>
<?php
	}

	/**
	 * 公開・非公開切り替え
	 */
	function publish($option, $publish = false) {
		global $database;
		global $mosConfig_live_site;
		$cid = $_POST['cid'] ? $_POST['cid'] : array();
		if (isset($_POST['id']) && $_POST['id']) {
			$cid = array($_POST['id']);
		}
		foreach ($cid as $id) {
			$row = new mosKingyoyaComment($database);
			$result = $row->load($id);
			if (!$result) continue;
			$row->publish = $publish ? true : false;
			$row->store();
		}
		mosRedirect("{$mosConfig_live_site}/administrator/index2.php?option={$option}", "公開しました。");
		exit;
	}

}

