<?php
/**
 * 金魚屋開発支援シリーズ
 * 金魚屋コメント登録コンポーネント
 * クラススクリプト
 * 
 * 金魚屋開発支援シリーズ
 * 
 * @package Joomla
 * @component com_kingyoya_comment
 * @copyright (C) 2008 金魚屋見聞録
 * @author 金魚屋・Ｊ・龍角
 * @version 1.0.0
 */

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

/**
 * パラメータ登録クラス
 */
class mosKingyoyaComment extends mosKingyoyaDBTable {

	/** @var string of group */
	var $group;
	/** @var string of target */
	var $target;
	/** @var string of name */
	var $name;
	/** @var string of comment text */
	var $comment;
	/** @var boolean of publish flag */
	var $publish;

	/**
	 * コンストラクタ
	 * @param database of db reference
	 */
	function mosKingyoyaComment(&$db) {
		parent::mosKingyoyaDBTable('#__kingyoya_comment', $db);
	}

	/**
	 * データ登録チェック
	 * @return boolean
	 */
	function check() {
		if (!$this->group) {
			$this->_error = "Failed get group";
			return false;
		}
		if (!is_string($this->group)) {
			$this->_error = "Failed get group: {$this->group}";
			return false;
		}
		if (!$this->target) {
			$this->_error = "Failed get target";
			return false;
		}
		if (!is_string($this->target)) {
			$this->_error = "Failed get target: {$this->target}";
			return false;
		}

		return true;
	}

	/**
	 * データ読み込み
	 * @param mixed int of id or resource of query result
	 * @return boolean true if success, false if fault
	 */
	function load($id) {
		$result = parent::load($id);
		if ($result) {
			$this->publish = $this->publish ? true : false;
		}
		return $result;
	}

	/**
	 * データ登録
	 * @return boolean
	 */
	function store() {
		$this->publish = $this->publish ? 1 : 0;
		$result = parent::store();
		$this->publish = $this->publish ? true : false;
		return $result;
	}

	/**
	 * データ検索
	 * @param int of offset
	 * @param int of limit
	 * @return boolean true if success, false if fault
	 */
	function find($offset=0,$limit=0) {
		if (isset($this->publish)) {
			$this->publish = $this->publish ? 1 : 0;
		}
		$result = parent::find($offset, $limit);
		if (isset($this->publish)) {
			$this->publish = $this->publish ? 1 : 0;
		}
		return $result;
	}

}
